{# spreadSheetElement #}
{# @since 2.0.0 #}
{# @version 2.0.1 #}
{% if warnings %}
    <div class='alert alert-warning'>
        <strong>{{ gT("questionSpreadsheetSurvey errors") }}</strong>
        <ul>
            {% for warning in warnings %}
            <li>{{ warning }}</li>
            {% endfor %}
        </ul>
    </div>
{% endif %}
{% set newcolumns = {} %}
{% for columnkey , column in spreadsheetOptions.jexcel.columns %}
    {% if column.source %}
        {% set newsource = {} %}
        {% for sourcekey , sourceorig in column.source %}
            {% set sourceem = {
                'id' : sourceorig.id,
                'name' : processString(sourceorig.name, 1)
            } %}
            {% set newsource = newsource|merge({(sourcekey):sourceem}) %}
        {% endfor %}
        {% set newcolumn = {
            'id' : column.id,
            'title' : column.title,
            'titleattr' : column.titleattr,
            'allowEmpty' : column.allowEmpty,
            'type' : column.type,
            'readOnly' : column.readOnly,
            'source' : newsource
        } %}
        {% set newcolumns = newcolumns|merge({(columnkey):newcolumn}) %}
    {% else %}
        {% set newcolumns = newcolumns|merge({(columnkey):column}) %}
    {% endif %}
{% endfor %}
<div class="text-center remove-after-jexcel"><i class="fa fa-spinner fa-spin fa-3x fa-fw"></i></div>
<div id="jexcel{{ inputName }}" class="speadsheet-element"
    data-relatedSurvey="{{ C.Html.encode(relatedSurvey) }}"
    data-inputid="answer{{ inputName }}"
    data-token="{{ C.Html.encode(token) }}"
    data-columns="{{ C.Html.encode(json_encode(newcolumns)) }}"
    data-updateurl="{{ C.Html.encode(spreadsheetOptions.updateUrl) }}"
    data-deleteurl="{{ C.Html.encode(spreadsheetOptions.deleteUrl) }}"
    data-resulturl="{{ C.Html.encode(spreadsheetOptions.resultUrl) }}"
></div>
{% set jexcelEm = spreadsheetOptions.jexcel %}
{% set jexcelEm = jexcelEm|merge({'columns':newcolumns}) %}
{% set spreadsheetOptions = spreadsheetOptions|merge({'jexcel':jexcelEm}) %}

<div class="answer-item text-item hidden" aria-hidden="true">
    {{ C.Html.textField(
        inputName,
        value,
        {
            'class' : 'form-control',
            'id' : 'answer'~inputName
        }
    ) }}
</div>
<script>
    $("#jexcel{{ inputName }}").on('jexcelloaded', function() {
        $("#question{{ qid }} .remove-after-jexcel").remove();
        $(this).find('[data-toggle="popover"]').popover({
            html: true,
            container: 'body',
            content: function() {
                return $("#"+$(this).attr('data-contentsource')).html();
            },
            template: '<div class="popover jexcel-popover" role="tooltip"><div class="arrow"></div><div class="popover-content"></div></div>'
        });
    });
    $('#answer{{ inputName }}').trigger('keyup');
    questionSpreadsheetSurvey.setSpreadsheet('jexcel{{ inputName }}',{{ json_encode(spreadsheetOptions) }});
</script>
